<?php

namespace EventPortal\AuthPassword\Http\Controllers;

use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;

class HandleEmailAction
{
    public function __invoke(Request $request): RedirectResponse
    {
        redirect()->setIntendedUrl($request->input('intended_url'));

        if (auth()->check()) {
            return redirect()->intended();
        }

        if ($this->tokenIsPresentAndValid($request->input('token'))) {
            return redirect()->route('create-password.index', ['token' => $request->input('token')]);
        }

        return redirect()->route('login.index');
    }

    private function tokenIsPresentAndValid(?string $token = null): bool
    {
        return $token !== null && config('auth.providers.users.model')::wherePasswordToken($token)->exists();
    }
}
